<?php
namespace JExtstore\Component\JChat\Administrator\Field;
/**  
 * @package JCHAT::CONFIG::administrator::components::com_jchat 
 * @subpackage Field
 * @author Joomla! Extensions Store
 * @copyright (C) 2015 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html   
 */ 
defined( '_JEXEC' ) or die( 'Restricted access' );
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;

/**
 * Form Field for translator status
 * @package JCHAT::CONFIG::administrator::components::com_jchat 
 * @subpackage Field
 * @since 2.4
 */
class LanguagetranslationcheckField extends FormField {
	/**
	 * The form field type.
	 *
	 * @var string
	 * @since 11.1
	 */
	protected $type = 'languagetranslationcheck';
	
	/**
	 * Method to get the radio button field input markup.
	 *
	 * @return string The field input markup.
	 *        
	 * @since 11.1
	 */
	protected function getInput() {
		// Initialize variables.
		$html = array ();
		
		
		// Initialize some field attributes.
		if(version_compare(PHP_VERSION, '5.4', '>=')) {
			$html [] = 	'<span data-bs-content="' . Text::_ ( 'COM_JCHAT_LANGUAGE_TRANSLATION_SUPPORTED_DESC') . 
						'" class="badge bg-success label-large hasPopover">' . '<span class="icon-checkmark" aria-hidden="true"></span>' . 
						Text::sprintf ( 'COM_JCHAT_LANGUAGE_TRANSLATION_SUPPORTED' ) . '</span>';
		} else {
			$html [] = 	'<span data-bs-content="' . Text::_ ( 'COM_JCHAT_LANGUAGE_TRANSLATION_NOTSUPPORTED_DESC' ) . 
						'" class="badge bg-danger label-large hasPopover">' . '<span class="icon-remove" aria-hidden="true"></span>' . 
						Text::sprintf ( 'COM_JCHAT_LANGUAGE_TRANSLATION_NOTSUPPORTED' ) . '</span>';
		}
		
		return implode ( $html );
	}
}
