<?php
namespace JExtstore\Component\JChat\Administrator\Table;
/**
 *
 * @package JCHAT::MESSAGES::administrator::components::com_jchat
 * @subpackage tables
 * @author Joomla! Extensions Store
 * @Copyright (C) 2015 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html 
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
use Joomla\CMS\Table\Table;
use Joomla\Database\DatabaseDriver;

/**
 * Messages table
 *
 * @package JCHAT::MESSAGES::administrator::components::com_jchat
 * @subpackage tables
 * @since 1.0
 */
class MessagesTable extends Table {
	/**
	 * @var int Primary key
	 */
	public $id = 0;
	/**
	 * @var string
	 */
	public $from = '';
	/**
	 * @var string
	 */
	public $to = '';
	/**
	 * @var int
	 */
	public $fromuser = null;
	/**
	 * @var int
	 */
	public $touser = null;
	/**
	 * @var string
	 */
	public $message = '';
	/**
	 * @var string
	 */
	public $sent = 0;
	/**
	 * @var int
	 */
	public $read = 0;
	/**
	 * @var string
	 */
	public $type = 'message';
	/**
	 * @var int
	 */
	public $status = 0;
	/**
	 * @var int
	 */
	public $clientdeleted = 0;
	/**
	 * @var string
	 */
	public $actualfrom = '';
	/**
	 * @var string
	 */
	public $actualto = '';
	/**
	 * @var int
	 */
	public $sentroomid = null;
	/**
	 * @var string
	 */
	public $ipaddress = null;
	
	/**
	 * Delete Table override
	 * @override
	 *
	 * @see Table::delete()
	 */
	public function delete($pk = null) {
		$messageDeleted = parent::delete($pk);
	
		if($messageDeleted) {
			// Delete reference table messages by foreign key
			$query = $this->_db->getQuery(true)->delete('#__jchat_public_readmessages');
			$query->where('messageid = ' . (int)$pk);
			// Check for a database error.
			try {
				$this->_db->setQuery($query);
				$this->_db->execute();
			} catch(\Exception $e) {
				$messageDeleted = false;
			}
		}
	
		return $messageDeleted;
	}
	
	/**
	 *
	 * @param
	 *        	database A database connector object
	 */
	function __construct(DatabaseDriver $db) {
		parent::__construct ( '#__jchat', 'id', $db );
	}
}