<?php
namespace JExtstore\Component\JChat\Administrator\View\Config;
/**
 *
 * @package JCHAT::CONFIG::administrator::components::com_jchat
 * @subpackage views
 * @subpackage config
 * @author Joomla! Extensions Store
 * @Copyright (C) 2015 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html 
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
use Joomla\CMS\Language\Text;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Uri\Uri;
use JExtstore\Component\JChat\Administrator\Framework\View as JChatView;

/**
 * Config view
 *
 * @package JCHAT::CONFIG::administrator::components::com_jchat
 * @subpackage views
 * @since 1.0
 */
class HtmlView extends JChatView {

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addDisplayToolbar() {
		$doc = $this->app->getDocument();
		ToolbarHelper::title( Text::_('COM_JCHAT_MAINTITLE_TOOLBAR') . Text::_('COM_JCHAT_CONFIG' ), 'jchat' );
		ToolbarHelper::save('config.saveentity', 'COM_JCHAT_SAVECONFIG');
		ToolbarHelper::custom('cpanel.display', 'home', 'home', 'COM_JCHAT_CPANEL', false);
	}
	
	/**
	 * Effettua il rendering dei tabs di configurazione del componente
	 * @access public
	 * @return void
	 */
	public function display($tpl = null) {
		$doc = $this->app->getDocument();
		$this->loadJQuery($doc);
		$this->loadBootstrap($doc);
		$this->loadSelect2($doc);
		
		// Inject js translations
		$translations = array (
				'COM_JCHAT_SELECT2_PLACEHOLDER',
				'COM_JCHAT_SELECT2_COPIED'
		);
		$this->injectJsTranslations($translations, $doc);
		
		$doc->getWebAssetManager()->registerAndUseStyle ( 'jchat.colorpicker', 'administrator/components/com_jchat/css/colorpicker.css');
		
		$doc->getWebAssetManager()->registerAndUseScript ( 'jchat.colorpicker', 'administrator/components/com_jchat/js/colorpicker.js', [], [], ['jquery']);
		
		$params = $this->get('Data');
		$form = $this->get('form');
		
		// Bind the form to the data.
		if ($form && $params) {
			$form->bind($params);
		}
		
		$this->params_form = $form;
		$this->params = $params;
		$this->fieldset = $this->getModel()->getState('fieldset');
		
		// Aggiunta toolbar
		$this->addDisplayToolbar();
		
		// Output del template
		parent::display();
	}
}
?>