<?php
namespace JExtstore\Component\JChat\Administrator\View\Emoticons;
/**
 * @package JCHAT::EMOTICONS::administrator::components::com_jchat
 * @subpackage views
 * @subpackage emoticons
 * @author Joomla! Extensions Store
 * @copyright (C) 2015 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html  
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
use Joomla\CMS\Language\Text;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Pagination\Pagination;
use Joomla\CMS\Form\Form;
use JExtstore\Component\JChat\Administrator\Framework\View as JChatView;

/**
 * @package JCHAT::EMOTICONS::administrator::components::com_jchat
 * @subpackage views
 * @subpackage emoticons
 * @since 3.2
 */
class HtmlView extends JChatView {
	/**
	 * Add the page title and toolbar.
	 */
	protected function addDisplayToolbar() {
		ToolbarHelper::title(  Text::_('COM_JCHAT_MAINTITLE_TOOLBAR') . Text::_( 'COM_JCHAT_EMOTICONS' ), 'jchat' );
		
		ToolbarHelper::custom('cpanel.display', 'home', 'home', 'COM_JCHAT_CPANEL', false);
	}
	
	/**
	 * Default display listEntities
	 *        	
	 * @access public
	 * @param string $tpl
	 * @return void
	 */
	public function display($tpl = 'list') {
		// Get main records
		$rows = $this->get ( 'Data' );
		$lists = $this->get ( 'Filters' );
		$total = $this->get ( 'Total' );
		
		$doc = $this->app->getDocument();
		$this->loadJQuery($doc);
		$this->loadBootstrap($doc);
		$doc->getWebAssetManager()->registerAndUseScript ( 'jchat.emoticons', 'administrator/components/com_jchat/js/emoticons.js', [], [], ['jquery']);
		$doc->getWebAssetManager()->registerAndUseStyle ( 'jchat.emoticons', 'administrator/components/com_jchat/css/emoticons.css');
		
		$doc->getWebAssetManager()->addInlineScript('var jchat_livesite="' . Uri::root(false) . '";');
		
		$doc->getWebAssetManager()->addInlineStyle('@media (max-width: 1200px) { body.admin.com_jchat { min-width: 1200px; }}');
		
		// Evaluate the preserve emoticon size
		if($this->getModel()->getComponentParams()->get('emoticons_original_size', 0)) {
			$doc->getWebAssetManager()->addInlineStyle("td img[data-mediapreview]{max-width:100%!important;}");
		}
		
		// Inject js translations
		$translations = array (
				'COM_JCHAT_EMOTICON_SAVED',
				'COM_JCHAT_INVALID_KEYCODE',
				'COM_JCHAT_INVALID_KEYCODE_DESC',
				'COM_JCHAT_INVALID_LINKURL',
				'COM_JCHAT_INVALID_LINKURL_DESC'
		);
		$this->injectJsTranslations($translations, $doc);
						
		$orders = array ();
		$orders ['order'] = $this->getModel ()->getState ( 'order' );
		$orders ['order_Dir'] = $this->getModel ()->getState ( 'order_dir' );
		// Pagination view object model state populated
		$pagination = new Pagination ( $total, $this->getModel ()->getState ( 'limitstart' ), $this->getModel ()->getState ( 'limit' ) );
		
		$this->user = $this->app->getIdentity ();
		$this->pagination = $pagination;
		$this->searchword = $this->getModel ()->getState ( 'searchword' );
		$this->lists = $lists;
		$this->orders = $orders;
		$this->items = $rows;
		$this->document = $doc;
		
		$jForm = new Form('jchat_emoticon');
		$this->mediaField = new \Joomla\CMS\Form\Field\MediaField();
		$this->mediaField->setForm($jForm);
		
		$element = new \SimpleXMLElement('<field/>');
		$element->addAttribute('class', 'mediaimagefield');
		$element->addAttribute('default', '');
		$this->mediaField->setup($element, null);
		
		// Aggiunta toolbar
		$this->addDisplayToolbar();
		
		parent::display ( $tpl );
	}
}