// Turn radios into btn-group
jQuery(function($) {
	/**
	 * Enables bootstrap popover
	 */
	$('#updatestatus label.hasPopover, #cpanel span.leftlabel').popover({trigger:'hover', placement:'right', html:1});
	$('label.hasPopover, button.hasPopover, div.hasPopover, span.hasPopover, img.hasPopover').popover({trigger:'hover', placement:'top', html:1});
	
	/**
	 * Enables bootstrap tooltip
	 */
	$('label.hasTooltip, img.hasTooltip, a.hasTooltip').tooltip({trigger:'hover', placement:'top'});
	$('img.google_translate').tooltip({trigger:'hover', placement:'right'});
	
	// Recover the legacy save order button in async way on the next cycle
	/**
	 * Remove empty ordering spans
	 */
	$('td.order > span').filter(function(){
		var hasChild = !$('a', this).length;
		return hasChild;
	}).remove();
	setTimeout(function(){
		$('a.saveorder').removeAttr('onclick').removeAttr('style');
	}, 1);

	/**
	 * Calendars
	 */
	if($.datepicker) {
		$('input[data-role=calendar]').datepicker({
			dateFormat:'yy-mm-dd',
			firstDay : 1
		}).prev('span').on('click', function(){
			$(this).datepicker('show');
		});
	}

	/**
	 * Turn requuired class into data-required
	 */
	$('input.required').attr('data-validation', 'required');
	
	/**
	 * Accordion panels local storage memoize and set open
	 */
	var defaultAccordionObject = {'jchat_accordion_cpanel':'jchat_stats', 
								  'jchat_accordion_help':'jchat_functionalities_frontend'
								 };
	$('div.accordion').on('shown.bs.collapse', function (event) {
		if(!$(event.target).hasClass('accordion-body')) {
			return;
		}
		event.stopPropagation();
		$('div.accordion-heading').removeClass('opened');
		var localStorageAccordion = $.jStorage.get('jchatAccordionOpened', defaultAccordionObject);
		localStorageAccordion[this.id] = event.target.id;
		$.jStorage.set('jchatAccordionOpened', localStorageAccordion);
		
		// Scroll to accordion header if needed
		if(document.body.scrollHeight > window.innerHeight) {
			$('html, body').animate({ scrollTop: parseInt($("#"+event.target.id).prev().offset().top) - 185}, 500);
		}
		// Add open state
		$(event.target).prev().addClass('opened');
	}).on('hidden.bs.collapse', function (event){
		// Check if stored accordions are managed as array of opened slides or mutex exclusions
		if(!$(event.target).hasClass('accordion-body')) {
			return;
		}
		event.stopPropagation();
		var localStorageAccordion = $.jStorage.get('jchatAccordionOpened', defaultAccordionObject);
		if(localStorageAccordion[this.id] == event.target.id) {
			delete localStorageAccordion[this.id];
			$.jStorage.set('jchatAccordionOpened', localStorageAccordion);
		}
		// Remove open state
		$(event.target).prev().removeClass('opened');
	});

	$.each($.jStorage.get('jchatAccordionOpened', defaultAccordionObject), function(namespace, element) {
		if($('#'+element, '#'+namespace).length) {
			$('#'+element, '#'+namespace).addClass('in').prev().addClass('opened');
		}
	});

	/**
	 * Tab panels local storage memoize and set open
	 */
	var defaultTabObject = {'tab_configuration':'general'};
	$('.nav.nav-tabs').on('shown.bs.tab', function (event) {
		var localStorageTab = $.jStorage.get('jchatTabOpened', defaultTabObject);
		localStorageTab[this.id] = $(event.target).data('element');
		$.jStorage.set('jchatTabOpened', localStorageTab);
	});
	// Check for a specific tab trigger using url hash
	var tabRequest = window.location.hash.substr(2);
	if(tabRequest) {
		$('a[data-element=' + tabRequest + ']').tab('show');
	}
	if(tabRequest == 'licensepreferences') {
		$('a[data-element=general]').tab('show');
		$('#params_registration_email-lbl').css('color', 'red');
		$('#params_registration_email').css('border', '2px solid red');
	}

	$.each($.jStorage.get('jchatTabOpened', defaultTabObject), function(namespace, element) {
		$('a[data-element='+element+']', '#'+namespace).tab('show');
	});

	// Manage the hide/show of subcontrols for chat rendering mode based on selected modality
	var chatRenderingMode = $('input[name=params\\[rendering_mode\\]]:checked').prop('value');
	if(chatRenderingMode != 'module') {
		$('div.module_rendering_ctrl').hide();
	}
	$('input[name=params\\[rendering_mode\\]]').on('change', function(){
		$('div.module_rendering_ctrl').toggle();
	});
	
	// Manage the hide/show of subcontrols for 3PD integration
	var integrationChosen = $('#params_3pdintegration').val();
	if(integrationChosen != 'easysocial') {
		$('*.easysocial_params').hide();
	}
	$('#params_3pdintegration').on('change', function(){
		if($(this).val() == 'easysocial') {
			$('*.easysocial_params').slideDown();
		} else {
			$('*.easysocial_params').slideUp();
		}
	});
	
	// Manage the hide/show of subcontrols for 3PD integration
	var guestModeChosen = $('#params_guestenabled').val();
	if(guestModeChosen != 2) {
		$('*.meetings_params').hide();
	}
	$('#params_guestenabled').on('change', function(){
		if($(this).val() == 2) {
			$('*.meetings_params').slideDown();
		} else {
			$('*.meetings_params').slideUp();
		}
	});
	
	// Initialize Select2 and add optional copier buttons
	if(typeof($.fn.select2) !== 'undefined') {
		var addSelect2Copier = function() {
			$('span.select2-selection__choice__copy').remove();
			var select2Deleter = $('span.select2-selection__choice__remove');
			if(select2Deleter.length) {
				select2Deleter.after('<span class="select2-selection__choice__copy icon-copy" data-role="copyclipboard"></span>');
			}
		}
		
		$('#params_predefined_answers, #participants').select2({
			tags : true,
			placeholder : COM_JCHAT_SELECT2_PLACEHOLDER
		}).on('select2:open',function(e){
			$('span.select2-dropdown').hide();
		}).on('select2:close',function(e){
			if(navigator.clipboard) {
				addSelect2Copier();
			}
		});
		
		setTimeout(function(){
			// Support for copy Clipoard buttons, new API and legacy API
			if(navigator.clipboard) {
				addSelect2Copier();
				$(document).on('click', 'span[data-role=copyclipboard]', function(jqEvent){
					navigator.clipboard.writeText($(this).parent('li.select2-selection__choice').text().substring(1))
					.then(function() {
						$(jqEvent.target).tooltip({trigger: 'click', placement:'top', 'title':COM_JCHAT_SELECT2_COPIED}).on('shown.bs.tooltip', function(){
							$('li.select2-selection__choice div.tooltip').css('margin-left', '100px');
							if($(jqEvent.target).parent('li.select2-selection__choice').is(':first-child')) {
								$('li.select2-selection__choice div.tooltip').css('margin-top', '25px');
							}
						}).tooltip('show');
						$(jqEvent.target).css({'color':'#00b300', 'font-weight':'bold'});
						setTimeout(function(){
							$(jqEvent.target).css({'color':'#333', 'font-weight':'normal'});
							$(jqEvent.target).tooltip('destroy');
							$('#params_predefined_answers').select2('close');
						}, 600);
					})
					.catch(function(err) {
					});
					return false;
				});
			}
		}, 0);
	}
	
	// Support for copy Clipoard buttons, new API and legacy API
	if(navigator.clipboard) {
		$('button[data-role=copyclipboard]').on('click', function(jqEvent){
			navigator.clipboard.writeText($(this).prev('input[data-role=copyclipboard]').val())
			.then(function() {
				var currentText = $(jqEvent.target).text();
				var copiedText = $(jqEvent.target).data('success');
				$(jqEvent.target).text(copiedText).removeClass('btn-success').addClass('btn-warning');
				setTimeout(function(){
					$(jqEvent.target).text(currentText).removeClass('btn-warning').addClass('btn-success');
				}, 2000);
			})
			.catch(function(err) {
			});
			return false;
		});
	} else {
		$('button[data-role=copyclipboard]').on('click', function(jqEvent){
			try {  
				var placeholderInput = $(this).prev('input[data-role=copyclipboard]').get(0).select();  
				// Now that we've selected the text, execute the copy command  
				var successful = document.execCommand('copy');  
				if(successful) {
					var currentText = $(this).text();
					var copiedText = $(this).data('success');
					$(this).text(copiedText).removeClass('btn-success').addClass('btn-warning');
					setTimeout(function(){
						$(jqEvent.target).text(currentText).removeClass('btn-warning').addClass('btn-success');
					}, 2000);
				}
				// Remove the selections - NOTE: Should use
				// removeRange(range) when it is supported  
				window.getSelection().removeAllRanges();  
			} catch(err) {  
			}
			return false;
		});
	}
});