<?php
// namespace administrator\components\com_jchat\tables;
/**
 *
 * @package JCHAT::FORM::components::com_jchat
 * @subpackage tables
 * @author Joomla! Extensions Store
 * @Copyright (C) 2015 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

/**
 * ORM Table for rooms entities
 *
 * @package JCHAT::FORM::components::com_jchat
 * @subpackage tables
 * @since 1.0
 */
class TableRooms extends JTable {
	/**
	 *
	 * @var int
	 */
	public $id = null;
	
	/**
	 *
	 * @var string
	 */
	public $name = null;
	
	/**
	 *
	 * @var string
	 */
	public $description = null;
	
	/**
	 *
	 * @var int
	 */
	public $checked_out = 0;
	
	/**
	 *
	 * @var datetime
	 */
	public $checked_out_time = '0000-00-00 00:00:00';
	
	/**
	 *
	 * @var int
	 */
	public $published = 1;
	
	/**
	 *
	 * @var int
	 */
	public $ordering = null;
	
	/**
	 *
	 * @var int
	 */
	public $access = null;
	
	/**
	 *
	 * @var string
	 */
	public $menuitems = null;
	
	/**
	 * Check Table override
	 * @override
	 *
	 * @see JTable::check()
	 */
	public function check() {
		// Name required
		if (! $this->name) {
			$this->setError ( JText::_ ( 'COM_JCHAT_VALIDATION_ERROR' ) );
			return false;
		}
		
		return true;
	}
	
	/**
	 * Binds a named array/hash to this object
	 *
	 * @override
	 *
	 * @access public
	 * @param
	 *        	mixed	Optional primary key. If not specifed, the value of current key is used
	 * @param boolean $saveTask
	 * @return boolean if successful
	 */
	function bind($from, $ignore = array(), $saveTask = false) {
		// Parent std load
		parent::bind ( $from, $ignore );
	
		// Serialize comma separated
		if (is_array ( $this->menuitems ) && $saveTask) {
			$this->menuitems = implode(',', $this->menuitems);
		}

		return true;
	}
	
	/**
	 * Loads a row from the database and binds the fields to the object properties
	 *
	 * @override
	 *
	 * @access public
	 * @param
	 *        	mixed	Optional primary key. If not specifed, the value of current key is used
	 * @return boolean if successful
	 */
	public function load($keys = null, $reset = true) {
		// If not $idEntity set return empty object
		if($keys) {
			if(!parent::load ( $keys, $reset )) {
				return false;
			}
		}
	
		// Unserialize comma separated
		if ($this->menuitems) {
			$this->menuitems = explode(',', $this->menuitems );
		} else {
			// Init qui
			$this->menuitems = array ();
		}
	
		return true;
	}
	
	/**
	 * Store Table override
	 * @override
	 *
	 * @see JTable::store()
	 */
	public function store($updateNulls = true) {
		// Force 0 to NULL and update nulls
		if($this->menuitems == '0') {
			$this->menuitems = null;
		}

		$result = parent::store($updateNulls);

		return $result;
	}
	
	/**
	 * Class constructor
	 *
	 * @param Object& $_db
	 *        	return Object&
	 */
	public function __construct($_db) {
		parent::__construct ( '#__jchat_rooms', 'id', $_db );
	}
}