<?php 
/** 
 * @package JCHAT::CPANEL::administrator::components::com_jchat
 * @subpackage views
 * @subpackage cpanel
 * @subpackage tmpl
 * @author Joomla! Extensions Store
 * @Copyright (C) 2015 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html 
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
use Joomla\CMS\Language\Text;
?>
<!-- CPANEL ICONS -->
<div class="accordion col col-lg-5" id="cpanel">
	<div class="card card-default">
		<div class="card-header accordion-toggle accordion_lightblue noaccordion">
 			<h4 class="card-title">
				<span class="fas fa-tasks" aria-hidden="true"></span>
				<?php echo Text::_('COM_JCHAT_FEATURES');?>
			</h4>
		</div>
	    <div class="card-body card-block card-block-whitebg p-2">
			<?php echo $this->icons; ?>
	    
			<div id="updatestatus">
			<?php 
			if(is_object($this->updatesData)) {
				if(version_compare($this->updatesData->latest, $this->currentVersion, '>')) {
					$updatesACLClass = $this->app->getIdentity()->authorise('core.manage', 'com_installer') ? 'bg-danger' : 'bg-warning';?>
					<a href="http://storejextensions.org/extensions/jchatsocial.html" target="_blank" alt="storejextensions link">
						<label data-bs-content="<?php echo Text::sprintf('COM_JCHAT_GET_LATEST', $this->currentVersion, $this->updatesData->latest, $this->updatesData->relevance);?>" class="badge <?php echo $updatesACLClass;?> hasPopover">
							<span class="icon-warning" aria-hidden="true"></span>
							<?php echo Text::sprintf('COM_JCHAT_OUTDATED', $this->updatesData->latest);?>
						</label>
					</a>
				<?php } else { ?>
					<label data-bs-content="<?php echo Text::sprintf('COM_JCHAT_YOUHAVE_LATEST', $this->currentVersion);?>" class="badge bg-success hasPopover">
						<span class="icon-checkmark" aria-hidden="true"></span>
						<?php echo Text::sprintf('COM_JCHAT_UPTODATE', $this->updatesData->latest);?>
					</label>	
				<?php }
			}
			?>
			</div>
		</div>
    </div>
</div>

<!-- RIGHT ACCORDION -->
<div class="accordion col col-lg-7 ps-3" id="jchat_accordion_cpanel">
	<div class="card card-default accordion-group">
    	<div class="card-header accordion-toggle" data-bs-toggle="collapse" data-bs-target="#jchat_stats">
      		<h3 class="card-title">
      			<span class="icon-chart" aria-hidden="true"></span>
      			<?php echo Text::_('COM_JCHAT_CPANEL_STATS');?>
			</h3>
    	</div>
    	
 		<div id="jchat_stats"  data-bs-parent="#jchat_accordion_cpanel" class="card-body card-block card-block-whitebg accordion-body accordion-chart collapse">
			<div class="accordion-inner">
				<div class="single_stat_container">
					<div class="statcircle">
						<span class="icon-users icon-large" aria-hidden="true"></span>
					</div>
					<ul class="subdescription_stats">
						<li class="es-stat-no"><?php echo $this->infodata['chart_users_canvas']['totalusers']; ?></li>
						<li class="es-stat-title"><?php echo Text::_('COM_JCHAT_TOTAL_USERS');?></li>
					</ul>
				</div>
				
				<div class="single_stat_container">
					<div class="statcircle">
						<span class="icon-users icon-large" aria-hidden="true"></span>
					</div>
					<ul class="subdescription_stats">
						<li class="es-stat-no"><?php echo $this->infodata['chart_users_canvas']['loggedusers']; ?></li>
						<li class="es-stat-title"><?php echo Text::_('COM_JCHAT_TOTAL_LOGGED_USERS');?></li>
					</ul>
				</div>
				
				<div class="chart_container">
					<canvas id="chart_users_canvas"></canvas>
				</div>
				
				<div class="single_stat_container">
					<div class="statcircle">
						<span class="icon-cancel-circle icon-large" aria-hidden="true"></span>
					</div>
					<ul class="subdescription_stats">
						<li class="es-stat-no"><?php echo $this->infodata['chart_videochat_canvas']['totalbannedusers']; ?></li>
						<li class="es-stat-title"><?php echo Text::_('COM_JCHAT_TOTAL_BANNED_USERS');?></li>
					</ul>
				</div>
				
				<div class="single_stat_container">
					<div class="statcircle">
						<span class="icon-camera-2 icon-large" aria-hidden="true"></span>
					</div>
					<ul class="subdescription_stats">
						<li class="es-stat-no"><?php echo $this->infodata['chart_videochat_canvas']['totalvideochatsessions']; ?></li>
						<li class="es-stat-title"><?php echo Text::_('COM_JCHAT_TOTAL_VIDEOCHAT_SESSIONS');?></li>
					</ul>
				</div>
				
				<div class="chart_container">
					<canvas id="chart_videochat_canvas"></canvas>
				</div>
				
				<div class="single_stat_container">
					<div class="statcircle">
						<span class="icon-mail icon-large" aria-hidden="true"></span>
					</div>
					<ul class="subdescription_stats">
						<li class="es-stat-no"><?php echo $this->infodata['chart_messages_canvas']['totalmessages']; ?></li>
						<li class="es-stat-title"><?php echo Text::_('COM_JCHAT_TOTAL_MESSAGES');?></li>
					</ul>
				</div>
				
				<div class="single_stat_container">
					<div class="statcircle">
						<span class="icon-flag-2 icon-large" aria-hidden="true"></span>
					</div>
					<ul class="subdescription_stats">
						<li class="es-stat-no"><?php echo $this->infodata['chart_messages_canvas']['totalfilemessages']; ?></li>
						<li class="es-stat-title"><?php echo Text::_('COM_JCHAT_TOTAL_MESSAGES_FILE');?></li>
					</ul>
				</div>
				
				<div class="chart_container">
					<canvas id="chart_messages_canvas"></canvas>
				</div>
				
			</div>
		</div>
	</div>
	
	<div class="card card-default accordion-group">
    	<div class="card-header accordion-toggle" data-bs-toggle="collapse" data-bs-target="#jchat_status">
			<h3 class="card-title">
				<span class="icon-help" aria-hidden="true"></span>
				<?php echo Text::_('COM_JCHAT_ABOUT');?>
			</h3>
    	</div>
	    <div id="jchat_status" data-bs-parent="#jchat_accordion_cpanel" class="card-body card-block accordion-body collapse">
	 		<div class="accordion-inner">
				<div class="single_container">
			 		<label class="badge bg-warning"><?php echo Text::_('COM_JCHAT_CURRENT_VERSION') . $this->currentVersion;?></label>
		 		</div>
		 		
		 		<div class="single_container">
			 		<label class="badge bg-primary"><?php echo Text::_('COM_JCHAT_AUTHOR_COMPONENT');?></label>
		 		</div>
		 		
		 		<div class="single_container">
			 		<label class="badge bg-primary"><?php echo Text::_('COM_JCHAT_SUPPORTLINK');?></label>
		 		</div>
		 		
		 		<div class="single_container">
			 		<label class="badge bg-primary"><?php echo Text::_('COM_JCHAT_DEMOLINK');?></label>
		 		</div>
			</div>
	    </div>
 	</div>
</div>

<form name="adminForm" id="adminForm" action="index.php">
	<input type="hidden" name="option" value="<?php echo $this->option;?>"/>
	<input type="hidden" name="task" value=""/>
</form>