<?php 
/** 
 * @package JCHAT::EMOTICONS::administrator::components::com_jchat
 * @subpackage views
 * @subpackage emoticons
 * @subpackage tmpl
 * @author Joomla! Extensions Store
 * @copyright (C) 2015 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html  
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
use Joomla\CMS\Language\Text;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Uri\Uri;
use JExtstore\Component\JChat\Administrator\Framework\Helpers\Html as JChatHelpersHtml;

// Ordering drag'n'drop management
$saveOrderingUrl = null;
if ($this->orders['order'] == 'ordering') {
	$saveOrderingUrl = 'index.php?option=com_jchat&task=emoticons.saveOrder&format=json&ajax=1';
	HTMLHelper::_('draggablelist.draggable');
}
?>
<form action="index.php" method="post" name="adminForm" id="adminForm">
	<table class="full headerlist">
		<tr>
			<td id="alert_append" class="left">
			</td>
			<td id="alert_append" class="right d-flex justify-content-end">
				<div class="input-group flex-end">
					<span class="input-group-text" aria-label="<?php echo Text::_('COM_JCHAT_STATE');?>"><span class="icon-filter" aria-hidden="true"></span> <?php echo Text::_('COM_JCHAT_STATE' ); ?></span>
					<label class="visually-hidden" for="filter_state"><?php echo Text::_('JLIB_HTML_SELECT_STATE');?></label>
					<?php
						echo $this->lists['state'];
					?>
					<label class="visually-hidden" for="limit"><?php echo Text::_('JGLOBAL_LIST_LIMIT');?></label>
					<?php
						echo $this->pagination->getLimitBox();
					?>
				</div>
			</td>
		</tr>
		<tr>
			<td colspan="100%">
				<?php echo $this->pagination->getListFooter(); ?>
			</td>
		</tr>
	</table>

	<table id="adminList" class="adminlist emoticons table table-striped table-hover">
	<thead>
		<tr>
			<th style="width:1%">
				<?php echo Text::_('COM_JCHAT_NUM' ); ?>
			</th>
			<th style="width:2%">
				<input type="checkbox" name="checkall-toggle" value="" onclick="Joomla.checkAll(this);" />
			</th>
			<th style="width:10%" class="d-none d-lg-table-cell">
				<?php echo Text::_('COM_JCHAT_EMOTICON_IMAGE' ); ?>
			</th>
			<th style="width:48%">
				<?php echo Text::_('COM_JCHAT_EMOTICON_LINKURL' ); ?>
			</th>
			<th style="width:12%" class="d-none d-lg-table-cell">
				<?php echo Text::_('COM_JCHAT_EMOTICON_KEYCODE' ); ?>
			</th>
			<th style="width:12%">
				<?php echo Text::_('COM_JCHAT_EMOTICON_SAVE' ); ?>
			</th>
			<th class="order d-none d-md-table-cell">
				<?php echo HTMLHelper::_('grid.sort', 'COM_JCHAT_ORDER', 'ordering', @$this->orders['order_Dir'], @$this->orders['order'], 'emoticons.display'); ?>
				<?php 
					if(isset($this->orders['order']) && $this->orders['order'] == 'ordering'):
						echo JChatHelpersHtml::order($this->items, 'filesave.png', 'emoticons.saveOrder'); 
					endif;
				 ?>
			</th>
			<th style="width:25%">
				<?php echo Text::_('COM_JCHAT_PUBLISHED' ); ?>
			</th>
			<th style="width:1%">
				<?php echo Text::_('COM_JCHAT_ID' ); ?>
			</th>
		</tr>
	</thead>
	<tbody <?php if ($saveOrderingUrl) :?> class="js-draggable" data-url="<?php echo $saveOrderingUrl; ?>" data-direction="<?php echo strtolower($this->orders['order_Dir']); ?>" <?php endif; ?>>
	<?php
	for ($i=0, $n=count( $this->items ); $i < $n; $i++) {
		$row = $this->items[$i];
		$checked = '<input type="checkbox" id="cb' . $i . '" name="cid[]" value="' . $row->id . '"/>';
		?>
		<tr>
			<td align="center">
				<?php echo $i + 1; ?>
			</td>
			<td>
				<?php echo $checked; ?>
			</td>
			<td class="sortable-adminlist-verysmall d-none d-lg-table-cell">
				<img data-mediapreview="1" src="<?php echo Uri::root(false) . $row->linkurl;?>"/>
			</td>
			<td class="emoticonimage sortable-adminlist-quitelarge" align="center">
				<?php
					$this->mediaField->value = null;
					if(isset($row->linkurl) && $row->linkurl) {
						$this->mediaField->value = $row->linkurl;
					}
					$this->mediaField->id = 'jform_media_identifier_' . ($row->id);
					$this->mediaField->name = 'jform_media_identifier_' . ($row->id);
					$this->mediaField->dataIdentifier = ($row->id);
					if(method_exists($this->mediaField, 'renderField')) {
						echo $this->mediaField->renderField(); // Joomla 3.3+
					} elseif(method_exists($this->mediaField, 'getControlGroup')) {
						echo $this->mediaField->getControlGroup(); // Joomla 3.2
					} else { }
				?>
			</td>
			<td align="center" class="d-none d-lg-table-cell sortable-adminlist-medium">
				<input style="width:80px" data-keycode="<?php echo $row->id;?>" value="<?php echo $row->keycode;?>"/>
			</td>
			<td align="center">
				<button class="btn btn-primary" data-action="save_emoticon" data-save="<?php echo $row->id;?>"><span class="icon-save" aria-hidden="true"></span> <?php echo Text::_('COM_JCHAT_EMOTICON_SAVENOW');?></button>
			</td>
			
			<td class="order d-none d-md-table-cell">
				<?php 
				$ordering = $this->orders['order'] == 'ordering'; 
				$disabled = $ordering ?  '' : 'disabled="disabled"';
				
				$iconClass = '';
				if (!$ordering) {
					$iconClass = ' inactive tip-top hasTooltip" title="' . HTMLHelper::tooltipText('JORDERINGDISABLED');
				}
				?>
				<div style="display:inline-block" class="sortable-handler<?php echo $iconClass ?>">
					<span class="icon-menu" aria-hidden="true"></span>
				</div>
				
				<span class="moveup" aria-hidden="true"><?php echo $this->pagination->orderUpIcon( $i, true, 'emoticons.moveorder_up', 'COM_JCHAT_MOVE_UP', $ordering); ?></span>
				<span class="movedown" aria-hidden="true"><?php echo $this->pagination->orderDownIcon( $i, $n, true, 'emoticons.moveorder_down', 'COM_JCHAT_MOVE_DOWN', $ordering); ?></span>
				<input type="text" name="order[]" size="5" value="<?php echo $row->ordering; ?>"  <?php echo $disabled; ?>  class="ordering_input" style="text-align: center" />
			</td>
			
			<td align="center">
				<fieldset class="btn-group radio" data-bs-toggle="buttons" data-action="state_emoticon" data-state="<?php echo $row->id;?>">
					<?php 
						$published = isset($row->published) ? $row->published : 1;
						echo JChatHelpersHtml::booleanlist( 'published' . $row->id, null, $published);
					?>
				</fieldset>
			</td>
			<td>
				<?php echo $row->id; ?>
			</td>
		</tr>
		<?php
	}
	?>
	</tbody>
	</table>

	<input type="hidden" name="section" value="view" />
	<input type="hidden" name="option" value="<?php echo $this->option;?>" />
	<input type="hidden" name="task" value="emoticons.display" />
	<input type="hidden" name="boxchecked" value="1" />
	<input type="hidden" name="filter_order" value="<?php echo @$this->orders['order'];?>" />
	<input type="hidden" name="filter_order_Dir" value="<?php echo @$this->orders['order_Dir'];?>" />
</form>