<?php 
/** 
 * @package JCHAT::MEETINGS::administrator::components::com_jchat
 * @subpackage views
 * @subpackage eventstats
 * @subpackage tmpl
 * @author Joomla! Extensions Store
 * @Copyright (C) 2015 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html  
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' ); 
?>
<form action="index.php" method="post" name="adminForm" id="adminForm" class="jchat_spaced_editform"> 
	<div class="accordion-group">
		<div class="accordion-heading opened">
			<div class="accordion-toggle noaccordion">
				<h4><span class="icon-pencil"></span><?php echo JText::_( 'COM_JCHAT_MEETING_DETAILS' ); ?></h4>
			</div>
		</div>
		<div id="details" class="accordion-body collapse in">
	      	<div class="accordion-inner">
				<table class="admintable">
				<tbody>
					<tr>
						<td class="key left_title">
							<label for="hash">
								<?php echo JText::_('COM_JCHAT_HASH' ); ?>:
							</label>
						</td>
						<td class="right_details">
							<?php if($this->record->hash):?>
								<input data-role="copyclipboard" class="inputbox" type="text" name="hash" id="hash" value="<?php echo $this->record->hash;?>" readonly/>
								<button data-role="copyclipboard" data-success="<?php echo JText::_('COM_JCHAT_COPY_CLIPBOARD_COPIED');?>" class="btn btn-mini btn-success"><?php echo JText::_('COM_JCHAT_COPY_CLIPBOARD');?></button>
							<?php else:?>
									-
							<?php endif;?>
						</td>
					</tr>
					<tr>
						<td class="key left_title">
							<label for="hash">
								<?php echo JText::_('COM_JCHAT_MEETING_LINK' ); ?>:
							</label>
						</td>
						<td class="right_details">
							<?php if($this->record->hash):?>
								<input data-role="copyclipboard" class="inputbox inputbox-large" type="text" value="<?php echo JRoute::link('site', 'index.php?option=com_jchat&view=form&meeting_hash=' . $this->record->hash, true, 0, true);?>" readonly disabled/>
								<button data-role="copyclipboard" data-success="<?php echo JText::_('COM_JCHAT_COPY_CLIPBOARD_COPIED');?>" class="btn btn-mini btn-success"><?php echo JText::_('COM_JCHAT_COPY_CLIPBOARD');?></button>
							<?php else:?>
								-
							<?php endif;?>
						</td>
					</tr>
					<tr>
						<td class="key left_title">
							<label for="name">
								<?php echo JText::_('COM_JCHAT_NAME' ); ?>:
							</label>
						</td>
						<td class="right_details">
							<input class="inputbox" type="text" name="name" id="name" data-validation="required" size="50" value="<?php echo $this->record->name;?>" />
						</td>
					</tr>
					<tr>
						<td class="key left_title">
							<label for="description">
								<?php echo JText::_('COM_JCHAT_DESCRIPTION' ); ?>:
							</label>
						</td>
						<td class="right_details">
							<textarea class="inputbox" type="text" name="description" id="description" rows="5" cols="80" ><?php echo $this->record->description;?></textarea>
						</td>
					</tr>
					<tr>
						<td class="key left_title">
							<label for="participants">
								<?php echo JText::_('COM_JCHAT_MEETINGS_PARTICIPANTS' ); ?>:
							</label>
						</td>
						<td class="right_details">
							<select id="params_predefined_answers" name="participants[]" id="participants" multiple>
								<?php
								if(!empty($this->record->participants)) {
									foreach ( $this->record->participants as $option ) {
										echo '<option value="' . htmlspecialchars($option, ENT_QUOTES, 'UTF-8', false) . '" selected="selected">' . $option . '</option>';
									}
								}
								?>
							</select>
						</td>
					</tr>
					
					<tr>
						<td class="key left_title">
							<label for="startdate">
								<?php echo JText::_('COM_JCHAT_MEETINGS_STARTDATE' ); ?>:
							</label>
						</td>
						<td class="right_details">
							<?php echo JHtml::calendar(JHtml::_('date', $this->record->start_datetime, JText::_('DATE_FORMAT_LC6')), 'start_datetime', 'start_datetime', JText::_('DATE_FORMAT_CALENDAR_DATETIME'), array('required'=>true, 'showTime'=>true, 'class' => 'required'));?>
						</td>
					</tr>
					<tr>
						<td class="key left_title">
							<label for="enddate">
								<?php echo JText::_('COM_JCHAT_MEETINGS_ENDDATE' ); ?>:
							</label>
						</td>
						<td class="right_details">
							<?php echo JHtml::calendar(JHtml::_('date', $this->record->end_datetime, JText::_('DATE_FORMAT_LC6')), 'end_datetime', 'end_datetime', JText::_('DATE_FORMAT_CALENDAR_DATETIME'), array('required'=>true, 'showTime'=>true, 'class' => 'required'));?>
						</td>
					</tr>
					
					<tr>
						<td class="key left_title">
							<label>
								<?php echo JText::_('COM_JCHAT_PUBLISHED' ); ?>:
							</label>
						</td>
						<td class="right_details">
							<fieldset class="radio btn-group">
								<?php echo $this->lists['published']; ?>
							</fieldset>
						</td>
					</tr>
				</tbody>
				</table>
			</div>
		</div>
	</div>
	
	<input type="hidden" name="option" value="<?php echo $this->option?>" />
	<input type="hidden" name="id" value="<?php echo $this->record->id; ?>" />
	<input type="hidden" name="ordering" value="<?php echo $this->record->ordering; ?>" />
	<input type="hidden" name="task" value="" />
</form>