<?php 
//namespace modules\mod_jchat_messaging
/**
 * @package JCHAT::modules
 * @subpackage mod_jchat_messaging
 * @author Joomla! Extensions Store
 * @copyright (C) 2013 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html
 */
defined ( '_JEXEC' ) or die ();

$user = JFactory::getUser();
if(!$user->id) {
	return;
}

// Include the login functions only once
require_once __DIR__ . '/helper.php';

// Load component translations
$jLang = JFactory::getLanguage ();
$jLang->load ( 'com_jchat', JPATH_ROOT . '/components/com_jchat', 'en-GB', true, true );
if ($jLang->getTag () != 'en-GB') {
	$jLang->load ( 'com_jchat', JPATH_SITE, null, true, false );
	$jLang->load ( 'com_jchat', JPATH_ROOT . '/components/com_jchat', null, true, false );
}

// Check for Joomla compatibility
if(version_compare(JVERSION, '4', '>=')) {
	$jLang->load('com_jchat.sys', JPATH_ROOT . '/administrator/components/com_jchat', 'en-GB', true, true);
	echo JText::_('COM_JCHAT_INSTALLED_VERSION_NOTCOMPATIBLE');
	return;
}

// Get component params
$cParams = JComponentHelper::getParams('com_jchat');

// Include component model
require_once JPATH_ADMINISTRATOR . '/components/com_jchat/framework/exception/exception.php';
require_once JPATH_ADMINISTRATOR . '/components/com_jchat/framework/model/model.php';
require_once JPATH_ADMINISTRATOR . '/components/com_jchat/framework/helpers/users.php';

// Instantiate model
JModelLegacy::addIncludePath(JPATH_SITE . '/components/com_jchat/models', 'JChatModel');
JTable::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_jchat/tables');

// Instantiate models object with Dependency Injection chain
$userSessionTable = JChatHelpersUsers::getSessiontable ();
$streamModel = JModelLegacy::getInstance ( 'Stream', 'JChatmodel', array (
		'sessiontable' => $userSessionTable
) );
		
$messagingModel = JModelLegacy::getInstance('Messaging', 'JChatModel', array (
				'streamModel' => $streamModel 
		));
 
$totalPmMessages = 0;
$pmData = ModJChatMessagingHelper::getData($cParams, $messagingModel);
if(is_array($pmData) && count($pmData)) {
	foreach ($pmData as $pmUserMessage) {
		$totalPmMessages += $pmUserMessage['newmessages'];
	}
}

$layout = $params->get ( 'layout', 'default' );

// Add stylesheet
$doc = JFactory::getDocument();
$doc->addStyleSheet(JUri::base(true) . '/modules/mod_jchat_messaging/assets/style.css');

$chatTemplate = $cParams->get('chat_template', 'default.css');
switch ($chatTemplate) {
	case 'black.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: #333}');
	break;
	case 'electric.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: rgb(212, 117, 83)}');
	break;
	case 'fire.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: #B44949}');
	break;
	case 'girls.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: #ef8ea2}');
	break;
	case 'gold.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: #8c6239}');
	break;
	case 'livesupport.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: #0858C2}');
	break;
	case 'livesupportchatbot.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: #3B5998}');
	break;
	case 'mobile.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: #627bae}');
	break;
	case 'nature.css':
		$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: #00C504}');
	break;
}

if($cParams->get('chat_color_override', null)) {
	$doc->addStyleDeclaration('#jes_mod_jchatpm .list-group-item.title{background-color: ' . $cParams->get('chat_color_override') . '}');
}

require JModuleHelper::getLayoutPath ( 'mod_jchat_messaging', $layout );